#include "precomp.h"

float frac( float f )
{
	return f - floor( f );
}

vec2 Hash2( vec2 p, float t ) // from: https://www.shadertoy.com/view/4djGRh
{
	float r = 523.0f * sinf( dot( p, vec2( 53.3158f, 43.6143f ) ) );
	return vec2( frac( 15.32354f * r + t ), frac( 17.25865f * r + t ) );
}

float Cells( vec2 p, float t )
{
	p *= 16;
	float d = 1.0e10;
	vec2 fp = vec2( floor( p.x ), floor( p.y ) );
	for (int xo = -1; xo <= 1; xo++) for (int yo = -1; yo <= 1; yo++)
	{
		vec2 tp = fp + vec2( (float)xo, (float)yo );
		tp = p - tp - Hash2( vec2( fmod( tp.x, 16.0f ), fmod( tp.y, 16.0f ) ), t ), d = min( d, dot( tp, tp ) );
	}
	return sqrtf( d );
}

// -----------------------------------------------------------
// Main application tick function
// -----------------------------------------------------------
void Game::Tick( float _DT )
{
	timer t;
	t.reset();
	#pragma omp parallel for 
	for (int y = 0; y < SCRHEIGHT; y++) 
	{
		for (int x = 0; x < SCRWIDTH; x++)
		{
			int c = (int)(255.0f * clamp( Cells( vec2( x / 500.0f, y / 500.0f ), 1.0f ), 0.0f, 1.0f ));
			screen->GetBuffer()[x + y * SCRWIDTH] = c + (c << 8) + (c << 16);
		}
	}
	printf( "execution time: %5.2f ms\n", t.elapsed() );
}